from sys import argv,exit
from defines import *
import threading
import thread
from socket import *

from string import capitalize

# necessary for retrieving information about personal ip and internet interface
import fcntl
import struct
import array

from transfer import Transmitter

class ResourceNode:
	
	def __init__(self, conf):
		#self.ip = self.get_ip_address(interface)
		#if not (self.ip):
		#	print "ERROR - Desired IP is not available in existing internet interfaces."
		#	exit(-1)
		
		#self.port = 6000
		
		t = Transmitter(conf)
		(self.ip, self.port) = t.resource
		
		# checks if IP is correct
		self.get_info()
		
		print "Resource's IP is ", self.ip, " port ", self.port

		self.receiver = Receiver(self)
		self.receiver.start()
		
		
	def get_info(self):
		# sets personal attributes such as node#, port and ip
		my_ip = self.ip
		
		valid_ip = filter(lambda ip: ip == my_ip, map((lambda interface:\
			self.get_ip_address(interface)), self.all_interfaces()))
				
		if not valid_ip:
			debug("ERROR - Given IP is not valid for available internet interfaces.")
			exit(-1)
		
		
	def get_ip_address(self, ifname):
		#  get the IP address associated with a network interface
		s = socket(AF_INET, SOCK_DGRAM)
		return inet_ntoa(fcntl.ioctl(s.fileno(),0x8915,struct.pack('256s', ifname[:15]))[20:24])

	def all_interfaces(self):
		# get names of all "up" network interfaces
		max_possible = 10  # arbitrary. raise if needed.
		bytes = max_possible * 32
		s = socket(AF_INET, SOCK_DGRAM)
		names = array.array('B', '\0' * bytes)
		# 0x8912 -> SIOCGIFCONF
		outbytes = struct.unpack('iL', fcntl.ioctl(s.fileno(), 0x8912, \
		struct.pack('iL', bytes, names.buffer_info()[0])))[0]
		namestr = names.tostring()
		return [namestr[i:i+32].split('\0', 1)[0] for i in range(0, outbytes, 32)]


class Receiver(threading.Thread):

	def __init__(self,Node):
		self.node = Node
		self.sck = socket(AF_INET,SOCK_DGRAM,0)
		try:
			self.sck.bind(('',int(self.node.port)))
		except:
			debug("ERROR - Kill last process starting on port %s()"%self.node.port)
		self.BUFSIZ = 1024
		threading.Thread.__init__(self)

	def run(self):
		while 1:
			msg,addr = self.sck.recvfrom(self.BUFSIZ)

			exec("thread.start_new_thread(self.receive%s, (addr,))"%capitalize(msg))
			
	def receiveBegin(self, addr):
		print "BEGIN: ip: ", addr[0], " port ", addr[1]
		
	def receiveEnd(self, addr):
		print "END  : ip: ", addr[0], " port ", addr[1], "\n"


if __name__ == "__main__":
	
	if len(argv) < 2:
		print "Please inform a configuration file"
		exit(-1)
	else:
		conf = argv[1]
		n = ResourceNode(conf)