from socket import *
from sys import exit
from string import strip,capitalize,atoi
import threading
from time import sleep

class Transmitter:
	
	def __init__(self,filename):
		
		# filename is a file with the IP/port list
		self.ip_list = self.readFile(filename)
		self.pending_msg = ""
		self.socket = socket(AF_INET,SOCK_DGRAM,0)
		if (self.socket < 0):
			print "ERROR - Could not open socket for sending"
			exit(-1)
	
	def readFile(self,filename):
		f = file(filename)
		info = f.readline()
		
		S, T = tuple(info.split())
		self.S = atoi(S)
		self.T = atoi(T)

		ip_port_list = map(strip,f.readlines())
		ip_list = map(lambda ip_port:tuple(ip_port.split()), ip_port_list)
		ip_list =  map(lambda (ip, port): (ip, int(port)), ip_list) # porta com valor inteiro

		self.resource = ip_list[0]
		ip_list.remove(self.resource)
		
		return ip_list
		

	def sendMsg(self, msg, ip):
		# msg is a XmlMessage instance.

		self.socket.sendto(msg.getText(),ip)
		# If we're using TCP, no need for that.
		
	def requestResource(self):
		self.socket.sendto("begin", self.resource)
		
	def releaseResource(self):
		self.socket.sendto("end", self.resource)
